﻿' Author: Le Duc Hong    www.vovisoft.com
Public Class vnTextbox
    Inherits System.Windows.Forms.TextBox
    Private EscapeFlag As Boolean   ' Set when user presses the back slash \
    Private mTypingStyle As String
    Private LastCh As String

    Private ChList(148) As String  ' List of character groups like "aáàảãạâ-ă"

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        mTypingStyle = "VNI"   ' use VNI typing style initially
        ChList(0) = "aáàảãạăắằẳẵặâấầẩẫậeéèẻẽẹêếềểễệiíìỉĩịoóòỏõọôốồổỗộơớờởỡợuúùủũụưứừửữựyýỳỷỹỵdđAÁÀẢÃẠĂẮẰẲẴẶÂẤẦẨẪẬEÉÈẺẼẸÊẾỀỂỄỆIÍÌỈĨỊOÓÒỎÕỌÔỐỒỔỖỘƠỚỜỞỠỢUÚÙỦŨỤƯỨỪỬỮỰYÝỲỶỸỴDĐ"
        ChList(1) = "aáàảãạâ-ă"
        ChList(2) = "a^àảãạấ-ắ"
        ChList(3) = "aá^ảãạầ-ằ"
        ChList(4) = "aáà^ãạẩ-ẳ"
        ChList(5) = "aáàả^ạẫ-ẵ"
        ChList(6) = "aáàảã^ậ-ặ"
        ChList(7) = "aắằẳẵặâ-^"
        ChList(8) = "ăắằẳẵặấ-ắ"
        ChList(9) = "ăắằẳẵặầ-ằ"
        ChList(10) = "ăắằẳẵặẩ-ẳ"
        ChList(11) = "ăắằẳẵặẫ-ẵ"
        ChList(12) = "ăắằẳẵặậ-ặ"
        ChList(13) = "aấầẩẫậ^-ă"
        ChList(14) = "âấầẩẫậấ-ắ"
        ChList(15) = "âấầẩẫậầ-ằ"
        ChList(16) = "âấầẩẫậẩ-ẳ"
        ChList(17) = "âấầẩẫậẫ-ẵ"
        ChList(18) = "âấầẩẫậậ-ặ"
        ChList(19) = "eéèẻẽẹê"
        ChList(20) = "e^èẻẽẹế"
        ChList(21) = "eé^ẻẽẹề"
        ChList(22) = "eéè^ẽẹể"
        ChList(23) = "eéèẻ^ẹễ"
        ChList(24) = "eéèẻẽ^ệ"
        ChList(25) = "eếềểễệ^"
        ChList(26) = "êếềểễệế"
        ChList(27) = "êếềểễệề"
        ChList(28) = "êếềểễệể"
        ChList(29) = "êếềểễệễ"
        ChList(30) = "êếềểễệệ"
        ChList(31) = "iíìỉĩị"
        ChList(32) = "i^ìỉĩị"
        ChList(33) = "ií^ỉĩị"
        ChList(34) = "iíì^ĩị"
        ChList(35) = "iíìỉ^ị"
        ChList(36) = "iíìỉĩ^"
        ChList(37) = "oóòỏõọôơ"
        ChList(38) = "o^òỏõọốớ"
        ChList(39) = "oó^ỏõọồờ"
        ChList(40) = "oóò^õọổở"
        ChList(41) = "oóòỏ^ọỗỡ"
        ChList(42) = "oóòỏõ^ộợ"
        ChList(43) = "oốồổỗộ^ơ"
        ChList(44) = "ôốồổỗộốớ"
        ChList(45) = "ôốồổỗộồờ"
        ChList(46) = "ôốồổỗộổở"
        ChList(47) = "ôốồổỗộỗỡ"
        ChList(48) = "ôốồổỗộộợ"
        ChList(49) = "oớờởỡợô^"
        ChList(50) = "ơớờởỡợốớ"
        ChList(51) = "ơớờởỡợồờ"
        ChList(52) = "ơớờởỡợổở"
        ChList(53) = "ơớờởỡợỗỡ"
        ChList(54) = "ơớờởỡợộợ"
        ChList(55) = "uúùủũụ-ư"
        ChList(56) = "u^ùủũụ-ứ"
        ChList(57) = "uú^ủũụ-ừ"
        ChList(58) = "uúù^ũụ-ử"
        ChList(59) = "uúùủ^ụ-ữ"
        ChList(60) = "uúùủũ^-ự"
        ChList(61) = "uứừửữự-^"
        ChList(62) = "ưứừửữự-ứ"
        ChList(63) = "ưứừửữự-ừ"
        ChList(64) = "ưứừửữự-ử"
        ChList(65) = "ưứừửữự-ữ"
        ChList(66) = "ưứừửữự-ự"
        ChList(67) = "yýỳỷỹỵ"
        ChList(68) = "y^ỳỷỹỵ"
        ChList(69) = "yý^ỷỹỵ"
        ChList(70) = "yýỳ^ỹỵ"
        ChList(71) = "yýỳỷ^ỵ"
        ChList(72) = "yýỳỷỹ^"
        ChList(73) = "d--------đ"
        ChList(74) = "d--------^"
        ChList(75) = "AÁÀẢÃẠÂ-Ă"
        ChList(76) = "A^ÀẢÃẠẤ-Ắ"
        ChList(77) = "AÁ^ẢÃẠẦ-Ằ"
        ChList(78) = "AÁÀ^ÃẠẨ-Ẳ"
        ChList(79) = "AÁÀẢ^ẠẪ-Ẵ"
        ChList(80) = "AÁÀẢÃ^Ậ-Ặ"
        ChList(81) = "AẮẰẲẴẶÂ-^"
        ChList(82) = "ĂẮẰẲẴẶẤ-Ắ"
        ChList(83) = "ĂẮẰẲẴẶẦ-Ằ"
        ChList(84) = "ĂẮẰẲẴẶẨ-Ẳ"
        ChList(85) = "ĂẮẰẲẴẶẪ-Ẵ"
        ChList(86) = "ĂẮẰẲẴẶẬ-Ặ"
        ChList(87) = "AẤẦẨẪẬ^-Ă"
        ChList(88) = "ÂẤẦẨẪẬẤ-Ắ"
        ChList(89) = "ÂẤẦẨẪẬẦ-Ằ"
        ChList(90) = "ÂẤẦẨẪẬẨ-Ẳ"
        ChList(91) = "ÂẤẦẨẪẬẪ-Ẵ"
        ChList(92) = "ÂẤẦẨẪẬẬ-Ặ"
        ChList(93) = "EÉÈẺẼẸÊ"
        ChList(94) = "E^ÈẺẼẸẾ"
        ChList(95) = "EÉ^ẺẼẸỀ"
        ChList(96) = "EÉÈ^ẼẸỂ"
        ChList(97) = "EÉÈẺ^ẸỄ"
        ChList(98) = "EÉÈẺẼ^Ệ"
        ChList(99) = "EẾỀỂỄỆ^"
        ChList(100) = "ÊẾỀỂỄỆẾ"
        ChList(101) = "ÊẾỀỂỄỆỀ"
        ChList(102) = "ÊẾỀỂỄỆỂ"
        ChList(103) = "ÊẾỀỂỄỆỄ"
        ChList(104) = "ÊẾỀỂỄỆỆ"
        ChList(105) = "IÍÌỈĨỊ"
        ChList(106) = "I^ÌỈĨỊ"
        ChList(107) = "IÍ^ỈĨỊ"
        ChList(108) = "IÍÌ^ĨỊ"
        ChList(109) = "IÍÌỈ^Ị"
        ChList(110) = "IÍÌỈĨ^"
        ChList(111) = "OÓÒỎÕỌÔƠ"
        ChList(112) = "O^ÒỎÕỌỐỚ"
        ChList(113) = "OÓ^ỎÕỌỒỜ"
        ChList(114) = "OÓÒ^ÕỌỔỞ"
        ChList(115) = "OÓÒỎ^ỌỖỠ"
        ChList(116) = "OÓÒỎÕ^ỘỢ"
        ChList(117) = "OỐỒỔỖỘ^Ơ"
        ChList(118) = "ÔỐỒỔỖỘỐỚ"
        ChList(119) = "ÔỐỒỔỖỘỒỜ"
        ChList(120) = "ÔỐỒỔỖỘỔỞ"
        ChList(121) = "ÔỐỒỔỖỘỖỠ"
        ChList(122) = "ÔỐỒỔỖỘỘỢ"
        ChList(123) = "OỚỜỞỠỢÔ^"
        ChList(124) = "ƠỚỜỞỠỢỐỚ"
        ChList(125) = "ƠỚỜỞỠỢỒỜ"
        ChList(126) = "ƠỚỜỞỠỢỔỞ"
        ChList(127) = "ƠỚỜỞỠỢỖỠ"
        ChList(128) = "ƠỚỜỞỠỢỘỢ"
        ChList(129) = "UÚÙỦŨỤ-Ư"
        ChList(130) = "U^ÙỦŨỤ-Ứ"
        ChList(131) = "UÚ^ỦŨỤ-Ừ"
        ChList(132) = "UÚÙ^ŨỤ-Ử"
        ChList(133) = "UÚÙỦ^Ụ-Ữ"
        ChList(134) = "UÚÙỦŨ^-Ự"
        ChList(135) = "UỨỪỬỮỰ-^"
        ChList(136) = "ƯỨỪỬỮỰ-Ứ"
        ChList(137) = "ƯỨỪỬỮỰ-Ừ"
        ChList(138) = "ƯỨỪỬỮỰ-Ử"
        ChList(139) = "ƯỨỪỬỮỰ-Ữ"
        ChList(140) = "ƯỨỪỬỮỰ-Ự"
        ChList(141) = "YÝỲỶỸỴ"
        ChList(142) = "Y^ỲỶỸỴ"
        ChList(143) = "YÝ^ỶỸỴ"
        ChList(144) = "YÝỲ^ỸỴ"
        ChList(145) = "YÝỲỶ^Ỵ"
        ChList(146) = "YÝỲỶỸ^"
        ChList(147) = "D--------Đ"
        ChList(148) = "D--------^"

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl1 overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

#End Region
    Property TypingStyle() As String
        Get
            Return mTypingStyle
        End Get
        Set(ByVal Value As String)
            ' Chỉ chấp nhận "VNI" hay "VIQR" mà thôi
            If Value = "VNI" Or Value = "VIQR" Then
                mTypingStyle = Value
            End If
        End Set
    End Property

    Protected Overrides Function ProcessKeyMessage(ByRef m As System.Windows.Forms.Message) As Boolean
        ' Get out if this is not a KeyUp message
        If m.Msg <> 258 Then Return False
        Const Delay As Integer = 100
        ' Obtain the Keystroke character
        Dim KeyChar As Integer = m.WParam.ToInt32
        ' Process a keystroke
        Dim Pos, ToneCharPos, Offset As Integer
        Dim NewCh As String
        If KeyChar = 8 Then  ' It's a backspace character
            If Me.SelectionStart = 0 Then Return True
            ' Obtain the position of the line containing all possible modified characters
            Pos = GetLastCharMapPos()
            ' Select the character just on the left of the cursor
            Me.SelectionStart -= 1
            Me.SelectionLength = 1
            If Pos > 0 Then
                If LastCh <> ChList(Pos).Substring(0, 1) Then
                    ' Get here if backspace means removing ^ or ', ` etc..
                    ' Copy the new (modified) character to clipboard, it's the leftmost
                    '            character on the line
                    Clipboard.SetDataObject(ChList(Pos).Substring(0, 1))
                    ' Paste it to replace the character on the left
                    Me.Paste()
                    ConcatCharacterIfFailed(ChList(Pos).Substring(0, 1))
                Else
                    ' get here if it's a genuine backspace
                    Me.Cut()
                End If
            Else
                ' Select the character just on the left of the cursor
                Me.Cut()
            End If
            ' Swallow the actual keystroke
            Return True
        ElseIf KeyChar = 92 Then  ' it's a back slash \ which is the Escape character
            If Not EscapeFlag Then
                EscapeFlag = True ' Set the Escape flag
                Return True ' Swallow the actual keystroke
            End If
        Else
            '    Map the key entered (i.e: "1".."9", "d", or "'", "`" , "?" , "~", ".", "+", "("  )
            '     to the position 1..9, to be used for selecting the new character from a string like:
            '  eg:  a  a' a` a? a~ a. a^ -  a(
            ToneCharPos = GetToneCharPos(KeyChar)
            If ToneCharPos > 0 Then
                ' Get here if a digit in range 1..9 has been entered
                ' Ignore the digit if Escape Flag is set
                If Not EscapeFlag Then
                    ' Obtain the position of the line containing all possible modified characters
                    Pos = GetLastCharMapPos()
                    ' If Pos = 0 then simply display the character, ie. leave the keystroke alone
                    If Pos > 0 Then
                        ' Work out the offset of the new character on the line
                        Offset = ToneCharPos + 1
                        If Offset <= ChList(Pos).Length Then
                            ' Extract the new character
                            NewCh = ChList(Pos).Substring(Offset - 1, 1)
                            ' Console.WriteLine("ChList:{0} Pos:{1} Offset-1:{2}", ChList(Pos), Pos, Offset - 1)
                            If NewCh = "^" Then  ' roll back last character
                                ' eg: letter a followed by 11 => á1 to become a1
                                ' Select the character just on the left of the cursor
                                Me.SelectionStart -= 1
                                Me.SelectionLength = 1
                                ' Copy leftmost character on the line to clipboard
                                Clipboard.SetDataObject(ChList(Pos).Substring(0, 1))
                                ' Paste it to replace the character on the left
                                Me.Paste()
                                ConcatCharacterIfFailed(ChList(Pos).Substring(0, 1))
                                ' Leave keystroke alone to let it fall through and be displayed
                                ' Forget it if the new character is "-", let the keystroke displayed
                            ElseIf NewCh <> "-" Then
                                ' Select the character just on the left of the cursor
                                Me.SelectionStart -= 1
                                Me.SelectionLength = 1
                                ' Copy the new (modified) character to clipboard
                                ToClipboard(NewCh)
                                ' Paste it to replace the character on the left
                                Me.Paste()
                                ConcatCharacterIfFailed(NewCh)
                                Return True  ' Swallow the actual keystroke
                            End If
                        End If
                    End If
                End If
            End If
        End If
        EscapeFlag = False  ' Reset the Escape Flag
    End Function

    Private Sub ConcatCharacterIfFailed(ByVal Ch As String)
        If Me.SelectionLength = 1 Then
            Dim SelPos As Integer = Me.SelectionStart
            Me.Text = Me.Text.Substring(0, SelPos) & Ch & Me.Text.Substring(SelPos + 1)
            Me.SelectionStart = SelPos + 1
            Me.SelectionLength = 0
        End If
    End Sub

    Private Function GetLastCharMapPos() As Integer
        ' Return the character on the left of the cursor in the Textbox
        If Me.SelectionStart > 0 Then
            ' Position SelStart one character to the left
            Me.SelectionStart -= 1
            Me.SelectionLength = 1  ' SelLength is just one character
            Me.Copy() ' Copy the character to the clipboard
            ' Put the cursor back to where it was before
            Me.SelectionStart += 1
            ' Create a new instance of the DataObject interface.
            Dim data As IDataObject = Clipboard.GetDataObject()
            '  Retrieve LastCh the character in Unicode Text format from clipboard
            LastCh = data.GetData(DataFormats.UnicodeText).ToString()
            ' Return the position of the LastCh character in the complete Vowel list
            GetLastCharMapPos = ChList(0).IndexOf(LastCh) + 1
        Else
            ' Cursor is at the leftmost position in the Textbox
            GetLastCharMapPos = 0
        End If
    End Function

    Private Function GetToneCharPos(ByVal KeyChar As Integer) As Integer
        ' If Typing stype is VNI, see if user enters "1".."9" or "d"
        ' If so return 1..9 and also 9 for "d". Otherwise return -1
        '
        ' If Typing stype is VIQR, return 1..9 for characters '`?~.^+(d . Otherwise return -1
        ' We also allow for * and - to be same as + and d successively.
        '   i.e. u+ or u*  and dd or d- are OK.
        GetToneCharPos = -1
        If mTypingStyle = "VNI" Then
            If (KeyChar = 68) Or (KeyChar = 100) Then   ' ie. "d" for dd or DD
                GetToneCharPos = 9
            ElseIf (KeyChar >= &H31) And (KeyChar <= &H39) Then
                ' it's a digit.  KeyChar of "1" is &H31
                GetToneCharPos = KeyChar - &H30
            End If
        ElseIf mTypingStyle = "VIQR" Then
            Console.WriteLine("KeyChar:{0}", KeyChar)
            Select Case KeyChar
                Case 39  '
                    GetToneCharPos = 1  ' '
                Case 96
                    GetToneCharPos = 2  ' `
                Case 126
                    GetToneCharPos = 4  ' ~
                Case 63
                    GetToneCharPos = 3  ' ?
                Case 46
                    GetToneCharPos = 5  '  .
                Case 94
                    GetToneCharPos = 6  ' ^
                Case 43, 42 ' + or *
                    GetToneCharPos = 7
                Case 40
                    GetToneCharPos = 8  ' (             
                Case 100, 68, 45   ' d  D or -
                    GetToneCharPos = 9
            End Select
        End If
    End Function

    Private Sub ToClipboard(ByVal Ch As String)
        ' Copy Unicode character Ch to clipboard
        LastCh = Ch ' Assign Ch to TextBox LastCh
        ' Copy it to clipboard
        Clipboard.SetDataObject(Ch)
    End Sub


End Class
